// H. Moessenboeck: Sprechen Sie Java? -- Kapitel 7, Aufgabe 5
// "Summe von Teilfolgen"

public class A5 {

	// Read a sequence of integers
	static int[] readSequence() {
		In.open("input.txt");
		int n = In.readInt();
		int[] a = new int[n];
		for (int i = 0; i < n; i++)
			a[i] = In.readInt();
		In.close();
		return a;
	}
	
	// Find the subsequence of a with the maximum sum
	static void findMaxSubSequence(int[] a) {
		int max = Integer.MIN_VALUE;
		int pos = -1, len = 0;
		for (int i = 0; i < a.length; i++) {
			int sum = 0;
			for (int j = i; j < a.length; j++) {
				sum += a[j];
				if (sum > max) {
					max = sum; pos = i; len = j - i + 1;
				}
			}
		}
		System.out.println("subsequence with maximal sum: pos = " 
			+ pos + ", length = " + len);
	}

	public static void main(String args[]) {
		int[] a = readSequence();
		for (int i = 0; i < a.length; i++) System.out.print(" " + a[i]);
		System.out.println();
		findMaxSubSequence(a);
	}
}

/*
Sample input:
10 2 4 -7 5 6 -5 9 -7 8 1
*/